/* generated using openapi-typescript-codegen -- do not edit */
/* istanbul ignore file */
/* tslint:disable */
/* eslint-disable */
import type { OwnershipTransferRequestIn } from '../models/OwnershipTransferRequestIn';
import type { OwnershipTransferRequestOut } from '../models/OwnershipTransferRequestOut';
import type { ResourceIn } from '../models/ResourceIn';
import type { ResourceOut } from '../models/ResourceOut';
import type { ResourceVersionStatus } from '../models/ResourceVersionStatus';
import type { UserSynchronizationRequestOut } from '../models/UserSynchronizationRequestOut';
import type { CancelablePromise } from '../core/CancelablePromise';
import { OpenAPI } from '../core/OpenAPI';
import { request as __request } from '../core/request';
export class ResourceService {
    /**
     * Request a new resource
     * Request a new resources.
     *
     * Permission `resource:create` required.
     * @param requestBody
     * @returns ResourceOut Successful Response
     * @throws ApiError
     */
    public static resourceCreateResource(
        requestBody: ResourceIn,
    ): CancelablePromise<ResourceOut> {
        return __request(OpenAPI, {
            method: 'POST',
            url: '/resources',
            body: requestBody,
            mediaType: 'application/json',
            errors: {
                400: `Error decoding JWT Token`,
                401: `Not Authenticated`,
                403: `Not Authorized`,
                404: `Entity not Found`,
                422: `Validation Error`,
            },
        });
    }
    /**
     * List resources
     * List all resources.
     *
     * Permission `resource:list` required.
     * @param maintainerId Filter for resource by maintainer. If current user is the same as maintainer ID, permission `resource:list` required, otherwise `resource:list_filter`.
     * @param versionStatus Which versions of the resource to include in the response. Permission `resource:list_filter` required if None or querying for non-public resources, otherwise only permission `resource:list` required.
     * @param nameSubstring Filter resources by a substring in their name.
     * @param _public Filter resources to by the public flag
     * @returns ResourceOut Successful Response
     * @throws ApiError
     */
    public static resourceListResources(
        maintainerId?: string,
        versionStatus?: Array<ResourceVersionStatus>,
        nameSubstring?: string,
        _public?: boolean,
    ): CancelablePromise<Array<ResourceOut>> {
        return __request(OpenAPI, {
            method: 'GET',
            url: '/resources',
            query: {
                'maintainer_id': maintainerId,
                'version_status': versionStatus,
                'name_substring': nameSubstring,
                'public': _public,
            },
            errors: {
                400: `Error decoding JWT Token`,
                401: `Not Authenticated`,
                403: `Not Authorized`,
                404: `Entity not Found`,
                422: `Validation Error`,
            },
        });
    }
    /**
     * List resource sync requests
     * List all resource sync requests.
     *
     * Permission `resource:update_any` required.
     * @returns UserSynchronizationRequestOut Successful Response
     * @throws ApiError
     */
    public static resourceListSyncRequests(): CancelablePromise<Array<UserSynchronizationRequestOut>> {
        return __request(OpenAPI, {
            method: 'GET',
            url: '/resources/sync_requests',
            errors: {
                400: `Error decoding JWT Token`,
                401: `Not Authenticated`,
                403: `Not Authorized`,
                404: `Entity not Found`,
            },
        });
    }
    /**
     * List resource OTRs
     * Get the ownership transfer requests for resources.
     *
     * Permission `resource:list` required if `current_owner_id` or `new_owner_id` is the current users id,
     * otherwise `resource:list_all`
     * @param currentOwnerId UID of user who is the current owner.
     * @param newOwnerId UID of user who will be the new owner.
     * @returns OwnershipTransferRequestOut Successful Response
     * @throws ApiError
     */
    public static resourceListResourceOtrs(
        currentOwnerId?: string,
        newOwnerId?: string,
    ): CancelablePromise<Array<OwnershipTransferRequestOut>> {
        return __request(OpenAPI, {
            method: 'GET',
            url: '/resources/ownership_transfer_request',
            query: {
                'current_owner_id': currentOwnerId,
                'new_owner_id': newOwnerId,
            },
            errors: {
                400: `Error decoding JWT Token`,
                401: `Not Authenticated`,
                403: `Not Authorized`,
                404: `Entity not Found`,
                422: `Validation Error`,
            },
        });
    }
    /**
     * Get a resource
     * Get a specific resource.
     *
     * Permission `resource:read` required.
     * @param rid
     * @param versionStatus Which versions of the resource to include in the response. Permission `resource:read_any` required if None or querying for non-public resources, otherwise only permission `resource:read` required.
     * @returns ResourceOut Successful Response
     * @throws ApiError
     */
    public static resourceGetResource(
        rid: string,
        versionStatus?: Array<ResourceVersionStatus>,
    ): CancelablePromise<ResourceOut> {
        return __request(OpenAPI, {
            method: 'GET',
            url: '/resources/{rid}',
            path: {
                'rid': rid,
            },
            query: {
                'version_status': versionStatus,
            },
            errors: {
                400: `Error decoding JWT Token`,
                401: `Not Authenticated`,
                403: `Not Authorized`,
                404: `Entity not Found`,
                422: `Validation Error`,
            },
        });
    }
    /**
     * Delete a resource
     * Delete a resources.
     *
     * Permission `resource:delete` required.
     * @param rid
     * @returns void
     * @throws ApiError
     */
    public static resourceDeleteResource(
        rid: string,
    ): CancelablePromise<void> {
        return __request(OpenAPI, {
            method: 'DELETE',
            url: '/resources/{rid}',
            path: {
                'rid': rid,
            },
            errors: {
                400: `Error decoding JWT Token`,
                401: `Not Authenticated`,
                403: `Not Authorized`,
                404: `Entity not Found`,
                422: `Validation Error`,
            },
        });
    }
    /**
     * Get a resource OTR
     * Get a specific resource ownership transfer request.
     *
     * Permission `resource:read` required if the current user is the current or new owner of the resource,
     * otherwise `resource:read_any` required.
     * @param rid
     * @returns OwnershipTransferRequestOut Successful Response
     * @throws ApiError
     */
    public static resourceGetResourceOtr(
        rid: string,
    ): CancelablePromise<OwnershipTransferRequestOut> {
        return __request(OpenAPI, {
            method: 'GET',
            url: '/resources/{rid}/ownership_transfer_request',
            path: {
                'rid': rid,
            },
            errors: {
                400: `Error decoding JWT Token`,
                401: `Not Authenticated`,
                403: `Not Authorized`,
                404: `Entity not Found`,
                422: `Validation Error`,
            },
        });
    }
    /**
     * Create a resource OTR
     * Create a ownership transfer request for a specific resource.
     *
     * Permission `resource:update` required if the current user is the current owner of the resource,
     * otherwise `resource:update_any` required.
     * @param rid
     * @param requestBody
     * @returns OwnershipTransferRequestOut Successful Response
     * @throws ApiError
     */
    public static resourceCreateResourceOtr(
        rid: string,
        requestBody: OwnershipTransferRequestIn,
    ): CancelablePromise<OwnershipTransferRequestOut> {
        return __request(OpenAPI, {
            method: 'POST',
            url: '/resources/{rid}/ownership_transfer_request',
            path: {
                'rid': rid,
            },
            body: requestBody,
            mediaType: 'application/json',
            errors: {
                400: `Error decoding JWT Token`,
                401: `Not Authenticated`,
                403: `Not Authorized`,
                404: `Entity not Found`,
                422: `Validation Error`,
            },
        });
    }
    /**
     * Accept a resource OTR
     * Accept an ownership transfer request for a specific resource.
     *
     * Permission `resource:update` required if the current user is the new owner of the resource,
     * otherwise `resource:update_any` required.
     * @param rid
     * @returns ResourceOut Successful Response
     * @throws ApiError
     */
    public static resourceAcceptResourceOtr(
        rid: string,
    ): CancelablePromise<ResourceOut> {
        return __request(OpenAPI, {
            method: 'PATCH',
            url: '/resources/{rid}/ownership_transfer_request',
            path: {
                'rid': rid,
            },
            errors: {
                400: `Error decoding JWT Token`,
                401: `Not Authenticated`,
                403: `Not Authorized`,
                404: `Entity not Found`,
                422: `Validation Error`,
            },
        });
    }
    /**
     * Delete a resource OTR
     * Delete/Reject a resource ownership transfer request.
     *
     * Permission `resource:update` required if the current user is the current or new owner of the resource,
     * otherwise `resource:update_any` required.
     * @param rid
     * @returns void
     * @throws ApiError
     */
    public static resourceDeleteResourceOtr(
        rid: string,
    ): CancelablePromise<void> {
        return __request(OpenAPI, {
            method: 'DELETE',
            url: '/resources/{rid}/ownership_transfer_request',
            path: {
                'rid': rid,
            },
            errors: {
                400: `Error decoding JWT Token`,
                401: `Not Authenticated`,
                403: `Not Authorized`,
                404: `Entity not Found`,
                422: `Validation Error`,
            },
        });
    }
}
